-- FILE: wutil.e
-- using c functions for word operations
-- motivated by TEA problems in straight Euphoria

include dll.e
constant dll_wutil = open_dll("wutil.dll")

constant wadd_ = define_c_func( dll_wutil, "_wadd", {C_ULONG,C_ULONG}, C_ULONG)
global function wadd(atom a, atom b)
    return c_func(wadd_, {a,b})
end function

constant wsub_ = define_c_func( dll_wutil, "_wsub", {C_ULONG,C_ULONG}, C_ULONG)
global function wsub(atom a, atom b)
    return c_func(wsub_, {a,b})
end function

constant wshift_ = define_c_func( dll_wutil, "_wshift", {C_ULONG,C_INT}, C_ULONG)
-- Right shift for n<0, Left shift for n>0
global function wshift(atom a, integer n)
    return c_func(wshift_, {a,n})
end function

constant wmod_ = define_c_func( dll_wutil, "_wmod", {C_ULONG,C_ULONG}, C_ULONG)
global function wmod(atom a, atom b)
    return c_func(wmod_, {a,b})
end function

constant wand_ = define_c_func( dll_wutil, "_wand", {C_ULONG,C_ULONG}, C_ULONG)
global function wand(atom a, atom b)
    return c_func(wand_, {a,b})
end function

constant wxor_ = define_c_func( dll_wutil, "_wxor", {C_ULONG,C_ULONG}, C_ULONG)
global function wxor(atom a, atom b)
    return c_func(wxor_, {a,b})
end function

